--------------------------------- Code by Tread ----- (Trealak on Steam) ---------------------------------
------------------------------- Developed For Tread's Fuel Types Framework -------------------------------
--------- inspired by FuelAPI and other mods by Konijima and Fuel Tank Vehicles by Planet Algol ----------

require "Vehicle/ISUI/ISVehiclePartMenu"
local Utils
local ActiveFuelAPI = false
if getActivatedMods():contains("FuelAPI") then--- If FuelAPI active - grab Utils from there
	Utils = require("FuelAPI/Utils");
	require "FuelAPI/CustomFuelObject"
	ActiveFuelAPI = true
else												--- else grab my file
	Utils = require("RS_FuelTypeAPI_Utils");
end

if not RSFuelTypes then RSFuelTypes = {} end ---RS Fuel Types init

local function setContains(set, key) --- function for checking if value is in the table
	return set[key] ~= nil
end


--[[-Remove the Native check from fuelling function, otherwise does not work on not perfectly zoned Storage Tanks---
function ISRefuelFromGasPump:isValid() --- 
	--return self.vehicle:isInArea(self.part:getArea(), self.character)
	return true
end
]]------------------------------------------------------------------------------------------------------------------

FuelTypesTableRS = FuelTypesTableRS or {}
FuelTypesTableRS["All"] = {"Gasoline", "Diesel", "LPG"} --- Add here ALL fuels available from gas pump
FuelTypesTableRS["Empty"] = {"Gasoline", "Diesel"}  --- Add here more fuel types IF suitable for general fuel storage
FuelTypesTableRS["Gasoline"] = {"Gasoline"}
FuelTypesTableRS["Diesel"] = {"Diesel"}
FuelTypesTableRS["LPG"] = {"LPG"}

------------------------------------------------------------------------------------------------------------------
---------------------- Code for Changing and Determining fuel Type in Storage Tanks - Tread ----------------------
function RSFuelTypes.SwapFuelTypeRS(playerObj, part, swapTo)
	---Swap Tank fuel type into "swapTo" value
--	print("RS Swap - Test: Veh" .. tostring(playerObj) .. " | " .. tostring(part:getVehicle():getId()) .. " | " .. tostring(part:getId()) .. " | " .. tostring(part:getModData().RSFuelType))
	sendClientCommand(playerObj, 'RS_FuelServer', 'RS_SetTankFuelType', { vehicle = part:getVehicle():getId(), part = part:getId(), type = swapTo })

	---If fuel type = "Empty" set content amount to 0
	if swapTo == "Empty" then
		local args = { vehicle = part:getVehicle():getId(), part = part:getId(), amount = 0 }
		sendClientCommand(playerObj, 'vehicle', 'setContainerContentAmount', args)
	end
end

function RSFuelTypes.DetermineFuelType(playerObj, part, partContentType) ---Function sets Fuel Type in tank based on its content
	local RSTankFuelType = nil
	if partContentType == "Gasoline Storage" or partContentType == "Gasoline" or partContentType == "Fuel Storage" then
		local fuelTypeChance = ZombRand(100);
		if fuelTypeChance <= 15 then
			RSTankFuelType = "Empty"
		elseif 15 < fuelTypeChance and fuelTypeChance <= 50 then
			RSTankFuelType = "Diesel"
		else
			RSTankFuelType = "Gasoline"
		end
	elseif partContentType == "Propane Storage" or partContentType == "Propane" or partContentType == "LPG" then
		RSTankFuelType = "LPG"
	elseif partContentType == "Diesel Storage" or partContentType == "Diesel" then
		RSTankFuelType = "Diesel"
	else
		RSTankFuelType = partContentType
	end

	if part:getModData().RSFuelType ~= RSTankFuelType then
		if isServer() or getWorld():getGameMode() ~= "Multiplayer" then	--- chunk for calls made by Server
		part:getModData().RSFuelType = RSTankFuelType
			part:getVehicle():transmitPartModData(part)
			print('Server Init FuelType:  ' .. RSTankFuelType)
			return RSTankFuelType
		end
		RSFuelTypes.SwapFuelTypeRS(playerObj, part, RSTankFuelType)
	end
	print('Init FuelType:  ' .. RSTankFuelType)
	return RSTankFuelType
end

function RSFuelTypes.DetermineMultiGasTankFuel(playerObj, part) ---Set Fuel Type in tank based on roll and RSMultiFuelSwapCars table
	local RSTankFuelType = nil
	local vehicleName = part:getVehicle():getScript():getFullName()
	print('VehName MultiFuel:  ' .. vehicleName)
	local fuelTypeChance = ZombRand(100);	--- roll
	local minRoll = 0
	local maxRoll = 0
	if RSMultiFuelSwapCars[vehicleName] ~= nil then
		for fuelType, fuelChance in pairs (RSMultiFuelSwapCars[vehicleName]) do
			if fuelChance ~=nil and fuelChance > 0 then
				maxRoll = maxRoll + fuelChance	--- set Top range of Fuel Type
				print('MultiFuel: Roll: ' .. fuelTypeChance .. " FuelType: " .. fuelType .. " Chance: " .. minRoll .."/" .. maxRoll)
				if minRoll < fuelTypeChance and fuelTypeChance <= maxRoll then RSTankFuelType = fuelType; break; end		--- assign fuel type if roll falls in range
				minRoll = maxRoll	--- set new Min range for next Fuel Type
			end
		end

	else
		RSTankFuelType = "Gasoline" --- if vehicle NOT in multi-fuel GasTank list.
	end
	if RSTankFuelType == nil then RSTankFuelType = "Gasoline" end --- If table was wrongly set up (roll not matched any FuelType) assign Native
	if part:getModData().RSFuelType ~= RSTankFuelType then
		if isServer() or getWorld():getGameMode() ~= "Multiplayer" then	--- chunk for calls made by Server
			part:getModData().RSFuelType = RSTankFuelType
			part:getVehicle():transmitPartModData(part)
			print('Server Init MultiFuel:  ' .. RSTankFuelType)
			return RSTankFuelType
		end
		RSFuelTypes.SwapFuelTypeRS(playerObj, part, RSTankFuelType)
	end
	print('Init MultiFuel:  ' .. RSTankFuelType)
	return RSTankFuelType
end

function RSFuelTypes.AcceptedFuelTypesTable(playerObj, part, partContentType)

	local FuelTypesTable = {}
	local gasTank = part:getVehicle():getPartById("GasTank") --- get Vehicle Gas Tank (part it drains fuel from) - Tread
	if part == gasTank then
		if not part:getTable("multigastank") then --- check if GasTank is not dynamically assigned
			if partContentType == "Diesel" then
				FuelTypesTable = FuelTypesTableRS["Diesel"]
			elseif partContentType == "LPG" or partContentType == "Propane Storage" or partContentType == "Propane" then
				FuelTypesTable = FuelTypesTableRS["LPG"]
			elseif partContentType == "Gasoline" or partContentType == "Gasoline Storage" then
				FuelTypesTable = FuelTypesTableRS["Gasoline"]
			---!!!! Add more elseif ... here for new fuels
			else --- add unknown custom fuel type to the list, by transcribing it
				FuelTypesTableRS[partContentType] = { partContentType }
				FuelTypesTable = FuelTypesTableRS[partContentType]
			end
		else
			local RSTankFuelType = part:getModData().RSFuelType
			if RSTankFuelType == nil then --- Set RSFuelType value if unassigned
				RSTankFuelType = RSFuelTypes.DetermineMultiGasTankFuel(playerObj, part)
			end

			FuelTypesTable = FuelTypesTableRS[RSTankFuelType]
		end
		print('GasTankFuel:  ' ..  FuelTypesTable[1])
	elseif part ~= gasTank then
		local RSTankFuelType = part:getModData().RSFuelType

		if RSTankFuelType == nil then --- Set RSFuelType value if unassigned
			RSTankFuelType = RSFuelTypes.DetermineFuelType(playerObj, part, partContentType)
		end

		FuelTypesTable = FuelTypesTableRS[RSTankFuelType]
		print('StorageFuel:  ' ..  RSTankFuelType)
	end

	return FuelTypesTable
end

------------------------------------------------------------------------------------------------------------------



------------------------------------------------------------------------------------------------------------------
----------------------------------------- Code for Storage Tanks - Tread -----------------------------------------
function RSFuelTypes.getNearbyFuelPumpRSStorage(vehicle, part) --- custom Fuel Pump finding function (so it works not only for Gas Tank parts) - Tread
	if not part then return nil end
	local areaCenter = vehicle:getAreaCenter(part:getArea())
	if not areaCenter then return nil end
	local square = getCell():getGridSquare(areaCenter:getX(), areaCenter:getY(), vehicle:getZ())
	if not square then return nil end
	for dy=-2,2 do
		for dx=-2,2 do
			-- TODO: check line-of-sight between 2 squares
			local square2 = getCell():getGridSquare(square:getX() + dx, square:getY() + dy, square:getZ())
			for i=0, square2:getObjects():size()-1 do
				local obj = square2:getObjects():get(i);
				if obj:getPipedFuelAmount() > 0 and obj:getModData().RSFuelType == nil then --- avoid Custom fuel objects
					return obj
				end
			end
		end
	end
end

function RSFuelTypes.onPumpFuelRS(playerObj, part, fuelStation, fuelType) --- custom fuelling call function (so it works not only for Gas Tank parts) - Tread
	if not part then return nil end
	if not fuelStation then return nil end
	if playerObj:getVehicle() then
		ISVehicleMenu.onExit(playerObj)
	end
	local square = fuelStation:getSquare();
	if square then
		local action = ISPathFindAction:pathToVehicleArea(playerObj, part:getVehicle(), part:getArea())
		action:setOnFail(ISVehiclePartMenu.onPumpGasolinePathFail, playerObj)
		ISTimedActionQueue.add(action)
		ISTimedActionQueue.add(ISRefuelFromGasPumpRSFuel:new(playerObj, part, fuelStation, fuelType, 100))
	end
end

function RSFuelTypes.onPumpFuelFromTruckRS(playerObj, part, source_Tank, fuelType) --- based on Blair Algol (PlanetAlgol) code
	if playerObj:getVehicle() then
		ISVehicleMenu.onExit(playerObj)
	end
	local square = source_Tank:getVehicle():getSquare()
	if square then
		local action = ISPathFindAction:pathToVehicleArea(playerObj, part:getVehicle(), part:getArea())
		action:setOnFail(ISVehiclePartMenu.onPumpGasolinePathFail, playerObj)
		ISTimedActionQueue.add(action)
		ISTimedActionQueue.add(ISRefuelFromFuelTruckRSFuel:new(playerObj, part, square, 100, source_Tank, fuelType))
	end
end

function RSFuelTypes.FindVehicleGasRS(playerObj, playerVehicle, fuelTypeArray) --- based on Blair Algol (PlanetAlgol) code
	local radius = 5
	local cell = playerObj:getCell()
	local vehicleList = cell:getVehicles()
	for index=0, vehicleList:size()-1 do
		local vehicle = vehicleList:get(index)
		for i=1,vehicle:getPartCount() do
			local part = vehicle:getPartByIndex(i-1)
			--- We want only containers which are not Tires or Gas Tank of a vehicle (so only Storage Tanks)
			local partContentType = part:getContainerContentType()
			if part:isContainer() and part:getCategory() ~= "tire" and part ~= vehicle:getPartById("GasTank") and setContains(contentTypeTableRS, partContentType) then
				if part:getContainerContentAmount() > 0 and vehicle ~= playerVehicle then
					local RSSourceFuelType = part:getModData().RSFuelType
					if RSSourceFuelType == nil then --- Set Source RSFuelType value if unassigned
						RSSourceFuelType = RSFuelTypes.DetermineFuelType(playerObj, part, partContentType)
					end
					for _, fuelType in pairs(fuelTypeArray) do
						if fuelType == RSSourceFuelType then --- check if Fuel Types match
							local square = vehicle:getSquare()
							x = math.abs(vehicle:getX()-playerObj:getX())
							y = math.abs(vehicle:getY()-playerObj:getY())
							if x < radius and y < radius then
--								print('RS Fuel Tank Veh Found')
								return part
							end
						end
					end
				end
			end
		end
	end
	return false
end


function ISVehiclePartMenu.onPumpFuelPathFail(playerObj) --- Say when Fuel Storage Tank cannot be reached
	playerObj:Say(getText("IGUI_PlayerText_NoWayToFuelTankInlet"));
end

function RSFuelTypes.EmptyTheTankRS(playerObj, part)	--- Empty the Fuel Storage Tank
	if playerObj:getVehicle() then
		ISVehicleMenu.onExit(playerObj)
	end

	action = ISPathFindAction:pathToVehicleArea(playerObj, part:getVehicle(), part:getArea())
	action:setOnFail(ISVehiclePartMenu.onPumpFuelPathFail, playerObj)
	ISTimedActionQueue.add(action)

	ISTimedActionQueue.add(ISEmptyTheTankRS:new(playerObj, part, 120))
end

if ActiveFuelAPI == true then
	function ISVehiclePartMenu.getNotFullNearbyFuelBarrels(part) --- Detect not full Fuel barrels - Tread
		local vehicle = part:getVehicle()
		local areaCenter = vehicle:getAreaCenter(part:getArea())
		if not areaCenter then return nil end
		local square = getCell():getGridSquare(areaCenter:getX(), areaCenter:getY(), vehicle:getZ())
		if not square then return nil end
		local result = {}
		for dy=-2,2 do
			for dx=-2,2 do
				local square2 = getCell():getGridSquare(square:getX() + dx, square:getY() + dy, square:getZ())

				for i=0, square2:getObjects():size()-1 do
					local obj = square2:getObjects():get(i);
					local FuelObject;
					FuelObject = CustomFuelObject:new(obj);
					if FuelObject then
						local fuelMax = FuelObject.fuelCapacity
						local fuelAmount = FuelObject:getFuelAmount()
--						print('RS Found Fuel Barrel ' .. fuelAmount .. "/" .. fuelMax)
						if fuelAmount < fuelMax then -- check if barrel is not full - Tread
							if ISVehiclePartMenu.RS_checkPathForWalls(square, square2, vehicle) then -- check if line between pump and water object is not blocked by wall - Tread
								table.insert(result, FuelObject)
							end
						end
					end
				end
			end
		end
		return result
	end

	function ISVehiclePartMenu.getNotEmptyNearbyFuelBarrels(part) --- Detect not empty Fuel barrels - Tread
	local vehicle = part:getVehicle()
		local areaCenter = vehicle:getAreaCenter(part:getArea())
		if not areaCenter then return nil end
		local square = getCell():getGridSquare(areaCenter:getX(), areaCenter:getY(), vehicle:getZ())
		if not square then return nil end
		local result = {}
		for dy=-2,2 do
			for dx=-2,2 do
				local square2 = getCell():getGridSquare(square:getX() + dx, square:getY() + dy, square:getZ())

				for i=0, square2:getObjects():size()-1 do
					local obj = square2:getObjects():get(i);
					local FuelObject;
					FuelObject = CustomFuelObject:new(obj);
					if FuelObject then
						local fuelAmount = FuelObject:getFuelAmount()
						if fuelAmount > 0 then
--							print('RS Found Full Fuel Barrel ' .. fuelAmount)
							if ISVehiclePartMenu.RS_checkPathForWalls(square, square2, vehicle) then -- check if line between pump and water object is not blocked by wall - Tread
								table.insert(result, FuelObject)
							end
						end
					end
				end
			end
		end
		return result
	end

	function ISVehiclePartMenu.pumpFuelTo(playerObj, part, pump)	--- Pump fuel to Barrel etc.
		if playerObj:getVehicle() then
			ISVehicleMenu.onExit(playerObj)
		end
		action = ISPathFindAction:pathToVehicleArea(playerObj, part:getVehicle(), part:getArea())
		action:setOnFail(ISVehiclePartMenu.onPumpFuelPathFail, playerObj)
		ISTimedActionQueue.add(action)
		ISTimedActionQueue.add(ISPumpFuelToBarrel:new(playerObj, part, pump, 1))
	end

	function ISVehiclePartMenu.pumpFuelFrom(playerObj, part, pump)	--- Pump fuel from Barrel etc.
	if playerObj:getVehicle() then
		ISVehicleMenu.onExit(playerObj)
	end
		action = ISPathFindAction:pathToVehicleArea(playerObj, part:getVehicle(), part:getArea())
		action:setOnFail(ISVehiclePartMenu.onPumpFuelPathFail, playerObj)
		ISTimedActionQueue.add(action)
		ISTimedActionQueue.add(ISPumpFuelFromBarrel:new(playerObj, part, pump, 1))
	end
end

--------------------------------------Tread: Adjusted/Overwriten functions by TIS - based off KONIJIMA's FuelAPI changes --------------------------------------------------------------------------------

local ISVehiclePartMenu_getGasCanNotEmpty = ISVehiclePartMenu.getGasCanNotEmpty;
function ISVehiclePartMenu.getGasCanNotEmpty(playerObj, typeToItem, fuelType, ...) -- added fuelType - Tread
	if fuelType == nil then fuelType = "Gasoline" end --- If function was called without fuelType, use default - Tread
	local fuelItem = nil
-- Uncomment after FuelAPI update
--	if fuelType == "Gasoline" then
--		fuelItem = ISVehiclePartMenu_getGasCanNotEmpty(playerObj, typeToItem, ...);
--	end

	if not fuelItem then
		local equipped = playerObj:getPrimaryHandItem();
		if equipped and Utils.PredicateNotEmpty(equipped) and fuelType == Utils.GetItemFuelType(equipped) then
		return equipped;
		end

		for fullType, items in pairs(typeToItem) do
			local gasCan = nil;
			local usedDelta = 1.1;
			for _,item in ipairs(typeToItem[fullType]) do
				if Utils.PredicateNotEmpty(item) and fuelType == Utils.GetItemFuelType(item) and item:getUsedDelta() < usedDelta then
				gasCan = item;
					usedDelta = gasCan:getUsedDelta();
				end
			end
			if gasCan then return gasCan; end
		end
		return nil;
	else
		return fuelItem;
	end
end

local ISVehiclePartMenu_getGasCanNotFull = ISVehiclePartMenu.getGasCanNotFull;
function ISVehiclePartMenu.getGasCanNotFull(playerObj, typeToItem, fuelType, ...) -- added fuelType - Tread
	if fuelType == nil then fuelType = "Gasoline" end --- If function was called without fuelType, use default - Tread
	local fuelItem = nil
-- Uncomment after FuelAPI update
--	if fuelType == "Gasoline" then
--		fuelItem = ISVehiclePartMenu_getGasCanNotFull(playerObj, typeToItem, ...);
--	end

	if not fuelItem then
		local equipped = playerObj:getPrimaryHandItem()
		if equipped and Utils.PredicateNotFull(equipped) and fuelType == Utils.GetItemFuelType(equipped) then
		return equipped;
		elseif equipped and Utils.PredicateEmpty(equipped) and equipped:getTags():contains("EmptyFuelContainer") then
		return equipped;
		end

		for fullType, items in pairs(typeToItem) do
			local gasCan = nil;
			local usedDelta = -1;
			for _,item in ipairs(typeToItem[fullType]) do
				if fuelType == Utils.GetItemFuelType(item) or item:getTags():contains("EmptyFuelContainer") then
					if Utils.PredicateNotFull(item) and item:getUsedDelta() > usedDelta then
						gasCan = item;
						usedDelta = gasCan:getUsedDelta();
					end
				end
			end
			if gasCan then return gasCan; end

			for _,item in ipairs(typeToItem[fullType]) do
				if Utils.PredicateEmpty(item) then
					return item;
				end
			end
		end
		return nil;
	else
		return fuelItem;
	end
end

-------------Tread - New Native overwrites ------------------

function ISVehiclePartMenu.onAddGasoline(playerObj, part, fuelItem, fuelType)
	if playerObj:getVehicle() then
		ISVehicleMenu.onExit(playerObj)
	end
	if fuelItem then --- swapped Item into fuelItem here and all lines below - Tread
	ISVehiclePartMenu.toPlayerInventory(playerObj, fuelItem)
		ISTimedActionQueue.add(ISPathFindAction:pathToVehicleArea(playerObj, part:getVehicle(), part:getArea()))
		ISInventoryPaneContextMenu.equipWeapon(fuelItem, true, false, playerObj:getPlayerNum())
		ISTimedActionQueue.add(ISAddGasolineToVehicle:new(playerObj, part, fuelItem, 50, fuelType))
	end
end


function ISVehiclePartMenu.onTakeGasoline(playerObj, part, fuelItem, fuelType)
	if playerObj:getVehicle() then
		ISVehicleMenu.onExit(playerObj)
	end
	if fuelItem then  --- swapped Item into fuelItem here and all below - Tread
	ISVehiclePartMenu.toPlayerInventory(playerObj, fuelItem)
		ISTimedActionQueue.add(ISPathFindAction:pathToVehicleArea(playerObj, part:getVehicle(), part:getArea()))
		ISInventoryPaneContextMenu.equipWeapon(fuelItem, false, false, playerObj:getPlayerNum())
		ISTimedActionQueue.add(ISTakeGasolineFromVehicle:new(playerObj, part, fuelItem, 50, fuelType))
	end
end


--------------------------------------Tread: AUX functions from and inspired by AdjacentFreeTileFinder functions by TIS ---------------------------------------------------------------------------------
ISVehiclePartMenu.RS_checkPathForWalls = function(src, test, vehicle) --  - Tread
    if src == nil or test == nil then return false; end
	
	local aX = src:getX()
	local aY = src:getY()
	local bX = test:getX()
	local bY = test:getY()
	local z = test:getZ()
	
	local diffX = math.abs(bX - aX)
	local diffY = math.abs(bY - aY)
	local stepX = ((bX-aX) / diffX) 
	local stepY = ((bY-aY) / diffY) 
	
	if stepX ~= stepX then stepX = 0 end --- check if stepX is NaN (from possible 0/0 above), change into 0 in such case - Tread
	if stepY ~= stepY then stepY = 0 end --- check if stepY is NaN (from possible 0/0 above), change into 0 in such case - Tread
	
	---------------code for checking vehicle tile -> water inlet tile blockades (parking against the wall and having "water inlet" on its other side ----------------
	local vehicleTile = vehicle:getSquare()
	local vX = vehicleTile:getX()
	local vY = vehicleTile:getY()
	local VdiffX = math.abs(vX - aX)
	local VdiffY = math.abs(vY - aY)
	local VstepX = ((vX-aX) / VdiffX) 
	local VstepY = ((vY-aY) / VdiffY) 
	if VstepX ~= VstepX then VstepX = 0 end --- check if stepX is NaN (from possible 0/0 above), change into 0 in such case - Tread
	if VstepY ~= VstepY then VstepY = 0 end --- check if stepY is NaN (from possible 0/0 above), change into 0 in such case - Tread
	------------------------------------------------------------------------------------------------------------------------------------------------------------------
	--print('DiffNR= ' .. diffX + diffY .. " aX, aY= " .. aX .. ", " .. aY .. " aX+1, aY+1= " .. aX + stepX .. ", " .. aY + stepY .. " bX, bY= " .. bX .. ", " .. bY)
	
	local t1 = getCell():getGridSquare(aX + VstepX, aY + VstepY, z) -- 1 tile towards vehicle (from water inlet) - Tread
	
	if src == test then --- If inlet over the world object then check whether car is not on the other side of some obstacle (than the inlet tile) - Tread
		--print('OneTile  ' .. 'DiffNR= ' .. diffX + diffY .. " aX, aY= " .. aX .. ", " .. aY .. " aX+1, aY+1= " .. aX + VstepX .. ", " .. aY + VstepY .. " test= " .. test:getX() .. ", " .. test:getY())
		if ISVehiclePartMenu.RS_privTrySquareForWalls(t1, src) then return true; else return false; end
	elseif diffX + diffY < 2 then --- if water object is just by the water inlet
		if ISVehiclePartMenu.RS_privTrySquare(test, src) and ISVehiclePartMenu.RS_privTrySquareForWalls(t1, src) then return true; end
	elseif diffX + diffY == 2 and diffX == diffY then -- same as above but diagonally
		if ISVehiclePartMenu.RS_privTrySquare(test, src) and ISVehiclePartMenu.RS_privTrySquareForWalls(t1, src) then return true; end
	elseif diffX + diffY >= 2 then --- if object is further, I never have more then 2, 2 vector from water inlet (limit in "getAllNearbyWaterTiles" function). Needs rewrite for bigger check zones - Tread
		local t2 = getCell():getGridSquare(aX + stepX, aY + stepY, z) --- "transit tile"
		if not ISVehiclePartMenu.RS_privTrySquareForWalls(src, t1) then return false; end --- inlet -> car check (otherwise parking against wall allowed pumping)
		if not ISVehiclePartMenu.RS_privTrySquareForWalls(src, t2) then return false; end --- inlet -> "transit tile" check
		if not ISVehiclePartMenu.RS_privTrySquareForWalls(t2, test) then return false; end --- "transit tile" -> water object check
		return true;
	end
	return false;
end	


ISVehiclePartMenu.RS_privTrySquareForWalls = function(src, test) --- redone TIS native function (so it allows open/smashed widows): AdjacentFreeTileFinder.privTrySquareForWalls
	if src:getX() < test:getX() and src:getY() == test:getY() then
		if test:Is(IsoFlagType.HoppableW) then return true; end								-- added "hoppable" check (low fences) - Tread
		if test:Is("DoorWallW") and not test:isDoorBlockedTo(src) then return true; end
		if test:Is("DoorW") and not test:isDoorBlockedTo(src) then return true; end			-- added other door check (fence gates etc.) - Tread
		if test:Is("WindowW") and not test:isWindowBlockedTo(src) then return true; end 	-- added window check - Tread
		if test:Is(IsoFlagType.windowW) and not test:isWindowBlockedTo(src) then return true; end -- "wall" (window and wall in one object) Window check - Tread
		if test:Is(IsoFlagType.cutW) or test:Is(IsoFlagType.collideW) then return false; end
	end
	if src:getX() > test:getX() and src:getY() == test:getY()  then
		if src:Is(IsoFlagType.HoppableW) then return true; end								-- added "hoppable" check (low fences) - Tread
		if src:Is("DoorWallW") and not src:isDoorBlockedTo(test) then return true; end
		if src:Is("DoorW") and not src:isDoorBlockedTo(test) then return true; end			-- added other door check (fence gates etc.) - Tread
		if src:Is("WindowW") and not src:isWindowBlockedTo(test) then return true; end 		-- added window check - Tread
		if src:Is(IsoFlagType.windowW) and not src:isWindowBlockedTo(test) then return true; end -- "wall" (window and wall in one object) Window check - Tread
		if src:Is(IsoFlagType.cutW)  or src:Is(IsoFlagType.collideW) then return false; end
	end

	if src:getY() < test:getY() and src:getX() == test:getX()  then
		if test:Is(IsoFlagType.HoppableN) then return true; end								-- added "hoppable" check (low fences) - Tread
		if test:Is("DoorWallN") and not test:isDoorBlockedTo(src) then return true; end
		if test:Is("DoorN") and not test:isDoorBlockedTo(src) then return true; end			-- added other door check (fence gates etc.) - Tread
		if test:Is("WindowN") and not test:isWindowBlockedTo(src) then return true; end 	-- added window check - Tread
		if test:Is(IsoFlagType.WindowN) and not test:isWindowBlockedTo(src) then return true; end -- "wall" (window and wall in one object) Window check - Tread
		if test:Is(IsoFlagType.cutN)  or test:Is(IsoFlagType.collideN)  then return false; end
	end
	if src:getY() > test:getY() and src:getX() == test:getX()  then
		if src:Is(IsoFlagType.HoppableN) then return true; end								-- added "hoppable" check (low fences) - Tread
		if src:Is("DoorWallN") and not src:isDoorBlockedTo(test) then return true; end
		if src:Is("DoorN") and not src:isDoorBlockedTo(test) then return true; end			-- added other door check (fence gates etc.) - Tread
		if src:Is("WindowN") and not src:isWindowBlockedTo(test) then return true; end 		-- added window check - Tread
		if src:Is(IsoFlagType.WindowN) and not src:isWindowBlockedTo(test) then return true; end -- "wall" (window and wall in one object) Window check - Tread
		if src:Is(IsoFlagType.cutN)  or src:Is(IsoFlagType.collideN) then return false; end
	end

    if src:getX() ~= test:getX() and src:getY() ~= test:getY() then
        if not ISVehiclePartMenu.RS_privTrySquareForWalls2(src, test:getX(), src:getY(), src:getZ()) or --- in TIS code one ) was missing here - Tread
            not ISVehiclePartMenu.RS_privTrySquareForWalls2(src, src:getX(), test:getY(), src:getZ()) or
            not ISVehiclePartMenu.RS_privTrySquareForWalls2(test, test:getX(), src:getY(), src:getZ()) or
            not ISVehiclePartMenu.RS_privTrySquareForWalls2(test, src:getX(), test:getY(), src:getZ()) then --- in TIS code one extra ) was here - Tread
            return false;
        end
    end

    return true;
end

ISVehiclePartMenu.RS_privTrySquareForWalls2 = function(src, x, y, z) --- redone native function (so it allows open/smashed widows): AdjacentFreeTileFinder.privTrySquareForWalls2
    return ISVehiclePartMenu.RS_privTrySquareForWalls(src, getCell():getGridSquare(x, y, z))
end

ISVehiclePartMenu.RS_privTrySquare = function(src, test) --- redone native function (so it allows open/smashed widows): AdjacentFreeTileFinder.privTrySquare
     --- if either is null, its not adjacent.
     if(src == nil or test == nil) then return false; end
     --- if either are on a different floor, not adjacent.
     if src:getZ() ~= test:getZ() then return false; end
     --- if there is a wall between the two tiles, not adjacent.
     if not ISVehiclePartMenu.RS_privTrySquareForWalls(src, test) then
         return false;
    end
	--- if the test one is solid / not walkable, not adjacent.
    --- if there is no floor on test, not adjacent.
    if not AdjacentFreeTileFinder.privCanStand(test) then
       return false;
    end
     --- adjacent!
    return true;
end
--------------------------------------------------------- End AUX functions from AdjacentFreeTileFinder ---------------------------------------------------------