--------------------------------- Code by Tread ----- (Trealak on Steam) ---------------------------------
------------------------------- Developed For Tread's Fuel Types Framework -------------------------------
--------- inspired by FuelAPI and other mods by Konijima and Fuel Tank Vehicles by Planet Algol ----------

--Done: Add Diesel items
--Done: Add adding/siphoning fuel with items
--Done: Add taking fuel from fuel pumps (to items)
--Done: Add fuelling from/to objects (barrels etc.)
--Done: Add fuel type change in receiving tank IF it was empty (fuelling between trucks)
--Done: Nie ma benzyny - nadpisać ten tekst (gdy brakuje paliwa)
--Done: Tekst na przedmiocie podczas pobierania/nalewania
--Done: Ikony customowe
--Done: Distributions - items
--Done: vehicles - assign new tanks functions etc.
--Done: vehicles - assign new tanks - Vehicle Lists
--Done: Turn off debug lines before release
--Done: Wywal testowe pojazdy - wcześniej skopiuj do "testowego" moda
--Done: item - propane tank add tags, add "that it stays after use"
--TODO: If "forcedfuel" and part type not in default parts table - transcribe ItemType from script - Vehicles.lua
--Done: LPG available at pump stations as sandbox Option
--Done: model/tekstury diesel przedmiotów
--TODO: Tooltips
--Done: Check LPG fuelling (station, truck, tanks)
--Done: Make mod work without FuelAPI
--Done: Make FuelAPI work without my mod
--Done: Add "gating" for FuelAPI by Barrel functions
--Done: Names in Mechanics overlay
--Done: Check fuel lvl update for tank stations in MP
--TODO: Empty the Gas Can etc.
--TODO: Pour between different gas can items (types) with same fuel type
--TODO: Fuelling from trucks - add line of sight check
--TODO: Nice-to-Have - fuel type visible on dashboard
--Done: Nice-to-Have - Sandbox options
--Done: Nice-to-Have - Different fuel usage per fuel type
--Done: Nice-to-Have - Optional Propane Tank add/siphon
--Done: Nice-to-Have - Vehicle Overlay for cisterns
--TODO: Nice-to-Have - More Sandbox options
--TODO: Nice-to-Have - Icons per fuel Type (barrels + Fuel Trucks)

require "Vehicles/ISUI/ISVehicleMenu"

local old_ISVehicleMenu_FillPartMenu = ISVehicleMenu.FillPartMenu
local ActiveFuelAPI = false
if getActivatedMods():contains("FuelAPI") then ActiveFuelAPI = true end

local function setContains(set, key) --- function for checking if value is in the table
    return set[key] ~= nil
end
---------------------------------------------------------------------------------------------------------------------
------------------------------------------- Table of Accepted "Fuel Types" ------------------------------------------
contentTypeTableRS = contentTypeTableRS or {}
contentTypeTableRS["Gasoline"] = true
contentTypeTableRS["Gasoline Storage"] = true
contentTypeTableRS["Fuel Storage"] = true
contentTypeTableRS["Diesel"] = true
contentTypeTableRS["Diesel Storage"] = true
contentTypeTableRS["Propane Storage"] = true
contentTypeTableRS["LPG"] = true
contentTypeTableRS["Propane"] = true
---!!!! Add similar in your code for new fuel types

---------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------

------------- copy of TIS function -------------------------------
local function getMoveableDisplayName(obj)
	if not obj then return nil end
	if not obj:getSprite() then return nil end
	local props = obj:getSprite():getProperties()
	if props:Is("CustomName") then
		local name = props:Val("CustomName")
		if props:Is("GroupName") then
			name = props:Val("GroupName") .. " " .. name
		end
		return Translator.getMoveableDisplayName(name)
	end
	return nil
end

function ISVehicleMenu.FillPartMenu(playerIndex, context, slice, vehicle)


	local playerObj = getSpecificPlayer(playerIndex);
	
	if playerObj:DistToProper(vehicle) >= 4 then
        return
    end
	local gasTank = vehicle:getPartById("GasTank") --- get Vehicle Gas Tank (part it drains fuel from) - Tread
	
-------------------- Generating context menu - Tread ------------------------------------	
	for i=1,vehicle:getPartCount() do
		local part = vehicle:getPartByIndex(i-1)
		local partContentType = part:getContainerContentType()

		if part:isContainer() and setContains(contentTypeTableRS, partContentType) then --- if content type is listed in contentTypeTableRS table ...

			-----------------------------------------------------------------------------
			-------------------------- Aux - Identify Fuel Type -------------------------
			local containerCapacity = part:getContainerCapacity()
			local containerContentAmount = part:getContainerContentAmount()
			local partModDataFuelType = part:getModData().RSFuelType
			local typeToItem = VehicleUtils.getItems(playerIndex)	--- Items suitable for fuelling/siphoning the tanks

			local GasFuellingArray = {} --- Array of values, differs per fuel type
			GasFuellingArray.FuelType = RSFuelTypes.AcceptedFuelTypesTable(playerObj, part, partContentType) --- List all accepted fuels

				----------------- Text & Icon assignments  + Redefine content of empty tanks -----------------
			if part == gasTank then --- if part is Gas Tank (engine uses its contents) - Tread
				GasFuellingArray.AddGasText = getText("IGUI_RS_VehicleAddTo")
				GasFuellingArray.SiphonGasText = getText("IGUI_RS_VehicleSiphonFrom")
				GasFuellingArray.RefuelFromPumpText =  getText("IGUI_RS_VehicleRefuelFromPump")
				GasFuellingArray.RefuelFromTruckText = getText("IGUI_RS_VehicleRefuelFromTruck")
			else
				if containerContentAmount == 0 and partModDataFuelType ~= "Empty" then --- Set "Empty" fuel type for suitable empty tanks
					for _, j in pairs(FuelTypesTableRS["Empty"]) do
						if j == partModDataFuelType then
							GasFuellingArray.FuelType = FuelTypesTableRS["Empty"]
							RSFuelTypes.SwapFuelTypeRS(playerObj, part, "Empty")
							break
						end
					end
				end
				GasFuellingArray.AddGasText = getText("IGUI_RS_StorageAddTo")
				GasFuellingArray.SiphonGasText = getText("IGUI_RS_StorageSiphonFrom")
				GasFuellingArray.RefuelFromPumpText = getText("IGUI_RS_StorageRefuelFromPump")
				GasFuellingArray.RefuelFromTruckText = getText("IGUI_RS_StorageRefuelFromTruck")
			end

			---------------------------------------------------------------------------------
			---------------------------------- Debug Options --------------------------------
--			if part ~= gasTank then
				---Debug options
--				if slice then else context:addOption("Swap Storage to Empty", playerObj, RSFuelTypes.SwapFuelTypeRS, part, "Empty") end --- Testing Option
--				if slice then else context:addOption("Swap Storage to Diesel", playerObj, RSFuelTypes.SwapFuelTypeRS, part, "Diesel") end --- Testing Option
--				if slice then else context:addOption("Swap Storage to Gasoline", playerObj, RSFuelTypes.SwapFuelTypeRS, part, "Gasoline") end --- Testing Option
--				if slice then else context:addOption("Swap Storage to LPG", playerObj, RSFuelTypes.SwapFuelTypeRS, part, "LPG") end --- Testing Option
--			end
			---------------------------------------------------------------------------------
			---------------------------------- Tank Not Full --------------------------------
			---------------------------------------------------------------------------------
			if containerContentAmount < containerCapacity then
			-----------------------------------------------------------------------------
			-------------------------- Fuelling  Tank from item -------------------------
				for _, fuelType in pairs(GasFuellingArray.FuelType) do
					if fuelType ~= "LPG" or UtilsRS.PropaneTankItemFuelling() ~= 1 then
						local fuelItem = ISVehiclePartMenu.getGasCanNotEmpty(playerObj, typeToItem, fuelType);
						if fuelItem then
							if slice then
								local sliceTexture = getTexture("media/ui/vehicles/vehicle_add_gas.png")
								if fuelType == "Gasoline" or fuelType == "Diesel" or fuelType == "LPG" then
									sliceTexture = getTexture("media/ui/vehicles/RS_Fuel_CanPlus_".. fuelType.. ".png")
								end
								slice:addSlice(string.format(GasFuellingArray.AddGasText, getText("IGUI_RSFuelType_" .. fuelType)), sliceTexture, ISVehiclePartMenu.onAddGasoline, playerObj, part, fuelItem, fuelType) ---added fuelType as parameter - Tread
							else
								context:addOption(string.format(GasFuellingArray.AddGasText, getText("IGUI_RSFuelType_" .. fuelType)), playerObj,ISVehiclePartMenu.onAddGasoline, part, fuelItem, fuelType)
							end
						end
					end
				end

			-----------------------------------------------------------------------------
			------------------------ Fuelling Tank from the pump ------------------------
				local fuelStation = RSFuelTypes.getNearbyFuelPumpRSStorage(vehicle, part)
				if fuelStation then
					local square = fuelStation:getSquare();
					if square and ((SandboxVars.AllowExteriorGenerator and square:haveElectricity()) or (SandboxVars.ElecShutModifier > -1 and GameTime:getInstance():getNightsSurvived() < SandboxVars.ElecShutModifier)) then
						if slice then
							for _, fuelType in pairs(GasFuellingArray.FuelType) do
								if fuelType ~= "LPG" or UtilsRS.PropaneOnGasStations() == 1 then
									local sliceTexture = getTexture("media/ui/vehicles/RS_Fuel_Pump_Other.png")
									if fuelType == "Gasoline" or fuelType == "Diesel" or fuelType == "LPG" then
										sliceTexture = getTexture("media/ui/vehicles/RS_Fuel_Pump_".. fuelType.. ".png")
									end
									slice:addSlice(string.format(GasFuellingArray.RefuelFromPumpText, getText("IGUI_RSFuelType_" .. fuelType)), sliceTexture, RSFuelTypes.onPumpFuelRS, playerObj, part, fuelStation, fuelType)
								end
							end
						else
							for _, fuelType in pairs(GasFuellingArray.FuelType) do
								if fuelType ~= "LPG" or UtilsRS.PropaneOnGasStations() == 1 then
									context:addOption(string.format(GasFuellingArray.RefuelFromPumpText, getText("IGUI_RSFuelType_" .. fuelType)), playerObj, RSFuelTypes.onPumpFuelRS, part, fuelStation, fuelType)
								end
							end
						end
					end
				end
			-----------------------------------------------------------------------------
			---------------------- Fuelling Tank from Storage Tank ----------------------
				local fuel_truck_source = RSFuelTypes.FindVehicleGasRS(playerObj, vehicle, GasFuellingArray.FuelType)
				if fuel_truck_source then
					if slice then
						for _, fuelType in pairs(GasFuellingArray.FuelType) do
							if fuel_truck_source:getModData().RSFuelType == fuelType then
								slice:addSlice(string.format(GasFuellingArray.RefuelFromTruckText, getText("IGUI_RSFuelType_" .. fuelType)), getTexture("media/ui/vehicles/RS_Fuel_FromStorageVeh.png"), RSFuelTypes.onPumpFuelFromTruckRS, playerObj, part, fuel_truck_source, fuelType)
							end
						end
					else
						for _, fuelType in pairs(GasFuellingArray.FuelType) do
							if fuel_truck_source:getModData().RSFuelType == fuelType then
								context:addOption(string.format(GasFuellingArray.RefuelFromTruckText, getText("IGUI_RSFuelType_" .. fuelType)), playerObj, RSFuelTypes.onPumpFuelFromTruckRS, part, fuel_truck_source, fuelType)
							end
						end
					end
				end

			-----------------------------------------------------------------------------
			--------------------- Pump from Barrel to Storage Tank ----------------------
				if ActiveFuelAPI == true then
					if part ~= gasTank then
						local fuelBarrels = ISVehiclePartMenu.getNotEmptyNearbyFuelBarrels(part)
						if #fuelBarrels > 0 then
							for _, fuelType in pairs(GasFuellingArray.FuelType) do
								local pumpFuelMenuInitialized = 0
								local pumpFuelMenu
								local subMenuPumpFuel
								if not slice then
									subMenuPumpFuel = ISContextMenu:getNew(context);
								end
								for j = 1, #fuelBarrels do
									local barrelFuelType = fuelBarrels[j].isoObject:getModData().RSFuelType
									if barrelFuelType == fuelType then
										if slice then
											local pump = fuelBarrels[j]
											local pumpName = getMoveableDisplayName(pump.isoObject)
											if pumpName == nil and instanceof(pump, "IsoWorldInventoryObject") and pump:getItem() then
												pumpName = pump:getItem():getDisplayName()
											end
											slice:addSlice(string.format(getText("IGUI_RS_ObjectPumpFrom") ,getText("IGUI_RSFuelType_" .. fuelType)) .. pumpName, getTexture("media/ui/vehicles/RS_Fuel_BarrelFrom.png"), ISVehiclePartMenu.pumpFuelFrom, playerObj, part, pump)
											break;
										else
											if pumpFuelMenuInitialized == 0 then
												pumpFuelMenu = context:addOption(string.format(getText("IGUI_RS_ObjectPumpFrom"), getText("IGUI_RSFuelType_" .. fuelType)))
												pumpFuelMenuInitialized = 1
											end
											local pump = fuelBarrels[j]
											local pumpName = getMoveableDisplayName(pump.isoObject)
											if pumpName == nil and instanceof(pump, "IsoWorldInventoryObject") and pump:getItem() then
												pumpName = pump:getItem():getDisplayName()
											end

											local option = subMenuPumpFuel:addOption(pumpName, playerObj, ISVehiclePartMenu.pumpFuelFrom, part, pump)

											local tooltip = ISToolTip:new();
											tooltip:setName(getText("IGUI_VehiclePart" .. fuelType .. "StorageTankRS"));
											local BarrelFuelTypeName = getText("IGUI_RSFuelType2_" .. fuelType)
											local tx = getTextManager():MeasureStringX(tooltip.font, BarrelFuelTypeName .. ":") + 20; --- Tread - show fuel Type in tooltip
											local fuelAmount = pump:getFuelAmount();
											if fuelAmount == -1 then
												fuelAmount = 0;
											end
											tooltip.description = string.format("%s: <SETX:%d> %d / %d", getText("IGUI_RSFuelType2_" .. fuelType), tx, containerContentAmount, containerCapacity);
											tooltip.description = tooltip.description .. " <BR>" .. (getText("IGUI_RS_Source") .. pumpName)
											tooltip.description = tooltip.description .. "\n" .. string.format("%s: <SETX:%d> %d / %d", getText("IGUI_RSFuelType2_" .. fuelType), tx, fuelAmount, pump.fuelCapacity)
											tooltip.maxLineWidth = 512;
											option.toolTip = tooltip

											context:addSubMenu(pumpFuelMenu, subMenuPumpFuel);
										end
									end
								end
							end
						end
					end
				end
			end
			---------------------------------------------------------------------------------
			---------------------------------- Tank Not Empty -------------------------------
			---------------------------------------------------------------------------------
			if containerContentAmount > 0 then
			-----------------------------------------------------------------------------
			--------------------------- Siphoning Tank to item --------------------------
				for _, fuelType in pairs(GasFuellingArray.FuelType) do
					if fuelType ~= "LPG" or part ~= gasTank or UtilsRS.PropaneTankItemFuelling() ~= 1 then
						local fuelItem = ISVehiclePartMenu.getGasCanNotFull(playerObj, typeToItem, fuelType);
						if fuelItem then
							if slice then
								local sliceTexture = getTexture("media/ui/vehicles/vehicle_siphon_gas.png")
								if fuelType == "Gasoline" or fuelType == "Diesel" or fuelType == "LPG" then
									sliceTexture = getTexture("media/ui/vehicles/RS_Fuel_CanMinus_".. fuelType.. ".png")
								end
								slice:addSlice(string.format(GasFuellingArray.SiphonGasText, getText("IGUI_RSFuelType_" .. fuelType)), sliceTexture, ISVehiclePartMenu.onTakeGasoline, playerObj, part, fuelItem, fuelType) ---added fuelType as parameter - Tread
							else
								context:addOption(string.format(GasFuellingArray.SiphonGasText, getText("IGUI_RSFuelType_" .. fuelType)), playerObj, ISVehiclePartMenu.onTakeGasoline, part, fuelItem, fuelType)
							end
						end
					end
				end
			-----------------------------------------------------------------------------
			--------------------------- Emptying Storage Tank ---------------------------
				if part ~= gasTank then
					for _, fuelType in pairs(GasFuellingArray.FuelType) do
						if fuelType == "Gasoline" or fuelType == "Diesel" then
							if slice then
								slice:addSlice(getText("IGUI_RS_EmptyFuelTank"), getTexture("media/ui/vehicles/RS_Fuel_Empty.png"), RSFuelTypes.EmptyTheTankRS, playerObj, part)
							else
								local emptyTank = context:addOption(getText("IGUI_RS_EmptyFuelTank"), playerObj, RSFuelTypes.EmptyTheTankRS, part)

							--[[	local tooltip = ISToolTip:new();
								tooltip:setName(getText("IGUI_VehiclePart" .. part:getId()));
								local tx = getTextManager():MeasureStringX(tooltip.font, getText("ContextMenu_WaterName") .. ":") + 20
								tooltip.description = string.format("%s: <SETX:%d> %d / %d", getText("ContextMenu_WaterName"), tx, waterTankContent, waterTankCapacity);
								if partData.tainted == 1 then
									tooltip.description = tooltip.description .. " <BR> <RGB:1,0.5,0.5> " .. getText("Tooltip_item_TaintedWater");
								end
								tooltip.maxLineWidth = 512;
								emptyTank.toolTip = tooltip;]]--
							end
						end
					end
				-----------------------------------------------------------------------------
				--------------------- Pump from Storage Tank to Barrel ----------------------
					if ActiveFuelAPI == true then
						local fuelBarrels = ISVehiclePartMenu.getNotFullNearbyFuelBarrels(part)
						if #fuelBarrels > 0 then
							for _, fuelType in pairs(GasFuellingArray.FuelType) do
								local pumpFuelMenuInitialized = 0
								local pumpFuelMenu
								local subMenuPumpFuel
								if not slice then
									subMenuPumpFuel = ISContextMenu:getNew(context);
								end
								for j = 1, #fuelBarrels do
									local barrelFuelType = fuelBarrels[j].isoObject:getModData().RSFuelType
									local NotLPGandEmpty = barrelFuelType == "Empty" and fuelType ~= "LPG"
									if NotLPGandEmpty or barrelFuelType == fuelType then
										if slice then
											local pump = fuelBarrels[j]
											local pumpName = getMoveableDisplayName(pump.isoObject)
											if pumpName == nil and instanceof(pump, "IsoWorldInventoryObject") and pump:getItem() then
												pumpName = pump:getItem():getDisplayName()
											end
											slice:addSlice(string.format(getText("IGUI_RS_ObjectPumpTo") ,getText("IGUI_RSFuelType_" .. fuelType)) .. pumpName, getTexture("media/ui/vehicles/RS_Fuel_BarrelTo.png"), ISVehiclePartMenu.pumpFuelTo, playerObj, part, pump)
											break;
										else
											if pumpFuelMenuInitialized == 0 then
												pumpFuelMenu = context:addOption(string.format(getText("IGUI_RS_ObjectPumpTo"), getText("IGUI_RSFuelType_" .. fuelType)))
												pumpFuelMenuInitialized = 1
											end
											local pump = fuelBarrels[j]
											local pumpName = getMoveableDisplayName(pump.isoObject)
											if pumpName == nil and instanceof(pump, "IsoWorldInventoryObject") and pump:getItem() then
												pumpName = pump:getItem():getDisplayName()
											end

											local option = subMenuPumpFuel:addOption(pumpName, playerObj, ISVehiclePartMenu.pumpFuelTo, part, pump)

											local tooltip = ISToolTip:new();
											tooltip:setName(pumpName);
											local BarrelFuelTypeName = getText("IGUI_RSFuelType2_" .. pump.isoObject:getModData().RSFuelType)
											local tx = getTextManager():MeasureStringX(tooltip.font, BarrelFuelTypeName .. ":") + 20; --- Tread - show fuel Type in tooltip
											local fuelAmount = pump:getFuelAmount();
											if fuelAmount == -1 then
												fuelAmount = 0;
											end
											tooltip.description = string.format("%s: <SETX:%d> %d / %d", BarrelFuelTypeName, tx, fuelAmount, pump.fuelCapacity);
											tooltip.description = tooltip.description .. " <BR>" .. (getText("IGUI_RS_Source") .. getText("IGUI_VehiclePart" .. fuelType .. "StorageTankRS"))
											tooltip.description = tooltip.description .. "\n" .. string.format("%s: <SETX:%d> %d / %d", getText("IGUI_RSFuelType2_" .. fuelType), tx, containerContentAmount, containerCapacity)
											tooltip.maxLineWidth = 512;
											option.toolTip = tooltip

											context:addSubMenu(pumpFuelMenu, subMenuPumpFuel);
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end

	old_ISVehicleMenu_FillPartMenu(playerIndex, context, slice, vehicle)

	---------------------------------------------------------------------------------------------------
	----- Remove Context Menu options I do not want  (they would double ones created by this mod) -----
	---------------------------------------------------------------------------------------------------
	local ContextMenuCleaningTable = {}
	ContextMenuCleaningTable[getText("ContextMenu_VehicleAddGas")] = true						---Native
	ContextMenuCleaningTable[getText("ContextMenu_VehicleSiphonGas")] = true
	ContextMenuCleaningTable[getText("ContextMenu_VehicleRefuelFromPump")] = true
	ContextMenuCleaningTable[getText("Add Gasoline From Fuel Truck")] = true
	ContextMenuCleaningTable[getText("Fill Gasoline Storage Tank From Fuel Truck")] = true		---FRUsedCars FuelTest
	ContextMenuCleaningTable[getText("Fill Gasoline Storage Tank From Pump")] = true
	ContextMenuCleaningTable[getText("Remove Gasoline From Gasoline Storage Tank")] = true
	ContextMenuCleaningTable[getText("Add Gasoline To Gasoline Storage Tank")] = true
	ContextMenuCleaningTable[getText("Remove Propane From Propane Storage Tank")] = true
	ContextMenuCleaningTable[getText("ContextMenu_Add_Gasoline_To_Gasoline_Storage_Tank")] = true	--- Autotsars Library
	ContextMenuCleaningTable[getText("ContextMenu_Remove_Gasoline_From_Gasoline_Storage_Tank")] = true
	ContextMenuCleaningTable[getText("ContextMenu_For_get_Gasoline_Need_Gas_Can")] = true
	ContextMenuCleaningTable[getText("ContextMenu_Fill_Gasoline_Storage_Tank_From_Pump")] = true
	ContextMenuCleaningTable[getText("ContextMenu_Fill_Gasoline_Storage_Tank_From_Fuel_Truck")] = true
	ContextMenuCleaningTable[getText("ContextMenu_Remove_Gasoline_From_Fuel_Truck")] = true

	if slice then
		slice:removeSliceByNames(ContextMenuCleaningTable)
	else
		context:removeOptionByNames(ContextMenuCleaningTable)
	end
	---------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------

end
