--------------------------------- Code by Tread ----- (Trealak on Steam) ---------------------------------
------------------------------- Developed For Tread's Fuel Types Framework -------------------------------
--------- inspired by FuelAPI and other mods by Konijima and Fuel Tank Vehicles by Planet Algol ----------

require "TimedActions/ISBaseTimedAction"

ISEmptyTheTankRS = ISBaseTimedAction:derive("ISRefuelFromGasPump")

function ISEmptyTheTankRS:isValid()
	return true;
end

function ISEmptyTheTankRS:waitToStart()
	self.character:faceThisObject(self.vehicle)
	return self.character:shouldBeTurning()
end


function ISEmptyTheTankRS:start()

	self:setActionAnim("fill_container_tap")
	self:setOverrideHandModels(nil, nil)
	
    self.sound = self.character:getEmitter():playSound("GeneratorLoop")
	self.sound2 = self.character:playSound("PourLiquidOnGround")
    addSound(self.character, self.character:getX(), self.character:getY(), self.character:getZ(), 10, 1)

    self.tankStart = self.part:getContainerContentAmount()
	self.amountSent = math.ceil(self.tankStart)
    self.action:setTime(self.tankStart * 35)
	
end

---stopSound
function ISEmptyTheTankRS:stopSound()
    if self.sound and self.character:getEmitter():isPlaying(self.sound) then
        self.character:stopOrTriggerSound(self.sound);
		self.character:stopOrTriggerSound(self.sound2);
    end
end

function ISEmptyTheTankRS:stop()
    self:stopSound()
	if self.part:getContainerContentAmount() == 0 then
		RSFuelTypes.SwapFuelTypeRS(self.character, self.part, "Empty")
	end
    ISBaseTimedAction.stop(self)
end

function ISEmptyTheTankRS:perform()
    self:stopSound()
	if self.part:getContainerContentAmount() == 0 then
		RSFuelTypes.SwapFuelTypeRS(self.character, self.part, "Empty")
	end
    ISBaseTimedAction.perform(self)
end

---update
function ISEmptyTheTankRS:update()
	self.character:faceThisObject(self.vehicle)


	local litres = self.tankStart + (0 - self.tankStart) * self:getJobDelta()
	litres = math.ceil(litres)
	if litres ~= self.amountSent then
		local args = { vehicle = self.vehicle:getId(), part = self.part:getId(), amount = litres }
		sendClientCommand(self.character, 'vehicle', 'setContainerContentAmount', args)
		self.amountSent = litres
	end
end

function ISEmptyTheTankRS:new(character, part, time)
	local o = {}
	setmetatable(o, self)
	self.__index = self
	o.character = character
	o.vehicle = part:getVehicle()
	o.part = part
	o.maxTime = time
	return o
end