--------------------------------- Code by Tread ----- (Trealak on Steam) ---------------------------------
------------------------------- Developed For Tread's Fuel Types Framework -------------------------------

require "TimedActions/ISBaseTimedAction"

ISPumpFuelFromBarrel = ISBaseTimedAction:derive("ISRefuelFromGasPump")

function ISPumpFuelFromBarrel:isValid()
	--return self.vehicle:isInArea(self.part:getArea(), self.character)
	return true;
end

function ISPumpFuelFromBarrel:waitToStart()
	self.character:faceThisObject(self.vehicle)
	return self.character:shouldBeTurning()
end

function ISPumpFuelFromBarrel:update()
	local litres = self.tankStart + self.takeLitres * self:getJobDelta()
	litres = math.ceil(litres)
	if self.part:getContainerContentAmount() ~= self.tankTarget and self.fuelStation:getFuelAmount() > 0 then
		local args = { vehicle = self.vehicle:getId(), part = self.part:getId(), amount = litres }
		sendClientCommand(self.character, 'vehicle', 'setContainerContentAmount', args)

		local drain = self.pumpStart - self.takeLitres * self:getJobDelta()
		drain = math.floor(drain)
		self.fuelStation:setFuelAmount(drain);
	end
	
   -- self.character:setMetabolicTarget(Metabolics.HeavyDomestic);
end

function ISPumpFuelFromBarrel:start()
	self.fuelType = self.fuelStation.isoObject:getModData().RSFuelType
	self.tankStart = self.part:getContainerContentAmount()
	self.pumpStart = self.fuelStation:getFuelAmount();
	local tankLitresFree = self.part:getContainerCapacity() - self.tankStart
	self.takeLitres = math.min(tankLitresFree, self.pumpStart)
	self.tankTarget = self.tankStart + self.takeLitres
	self.pumpTarget = self.pumpStart - self.takeLitres

	self.action:setTime(self.takeLitres * 10)

	self:setActionAnim("fill_container_tap")
	self:setOverrideHandModels(nil, nil)
	
	self.sound = self.character:playSound("GeneratorLoop")
	self.sound2 = self.character:playSound("GetWaterFromTapMetalBig")
	addSound(self.character, self.character:getX(), self.character:getY(), self.character:getZ(), 10, 1)


end

---stopSound
function ISPumpFuelFromBarrel:stopSound()
    if self.sound and self.character:getEmitter():isPlaying(self.sound) then
        self.character:stopOrTriggerSound(self.sound);
		self.character:stopOrTriggerSound(self.sound2);
    end
end

function ISPumpFuelFromBarrel:stop()
	self:stopSound()
	if self.part:getContainerContentAmount() > 0 and self.part:getModData().RSFuelType ~= self.fuelType  then
		RSFuelTypes.SwapFuelTypeRS(self.character, self.part, self.fuelType)
	end
	if self.fuelType and self.fuelType ~= "LPG" and  self.fuelStation.isoObject:getModData().fuelAmount <= 0 then --- Tread - Object has Fuel Type parameter and is empty
		self.fuelStation.isoObject:getModData().RSFuelType = "Empty" --- Tread - Set Barrel to Empty Fuel type
		self.fuelStation.isoObject:transmitModData();
	end
	ISBaseTimedAction.stop(self)
end

function ISPumpFuelFromBarrel:perform()
	self:stopSound()
	if self.part:getContainerContentAmount() > 0 and self.part:getModData().RSFuelType ~= self.fuelType then
		RSFuelTypes.SwapFuelTypeRS(self.character, self.part, self.fuelType)
	end
	if self.fuelType and self.fuelType ~= "LPG" and  self.fuelStation.isoObject:getModData().fuelAmount <= 0 then --- Tread - Object has Fuel Type parameter and is empty
		self.fuelStation.isoObject:getModData().RSFuelType = "Empty" --- Tread - Set Barrel to Empty Fuel type
		self.fuelStation.isoObject:transmitModData();
	end
	-- needed to remove from queue / start next.
	ISBaseTimedAction.perform(self)
end

function ISPumpFuelFromBarrel:new(character, part, fuelStation, time)
	local o = {}
	setmetatable(o, self)
	self.__index = self
	o.character = character
	o.vehicle = part:getVehicle()
	o.part = part
	o.fuelStation = fuelStation;
	--o.maxTime = math.max(time, 50)
	o.maxTime = time
	return o
end

