--------------------------------- Code by Tread ----- (Trealak on Steam) ---------------------------------
------------------------------- Developed For Tread's Fuel Types Framework -------------------------------

require "TimedActions/ISBaseTimedAction"

ISPumpFuelToBarrel = ISBaseTimedAction:derive("ISRefuelFromGasPump")

function ISPumpFuelToBarrel:isValid()
	--return self.vehicle:isInArea(self.part:getArea(), self.character)
	return true;
end

function ISPumpFuelToBarrel:waitToStart()
	self.character:faceThisObject(self.vehicle)
	return self.character:shouldBeTurning()
end

function ISPumpFuelToBarrel:update()
	local litres = self.barrelStart + self.giveLitres * self:getJobDelta()
	local drain = self.tankStart - self.giveLitres * self:getJobDelta()
	litres = math.ceil(litres)
	drain = math.floor(drain)
	if self.fuelStation:getFuelAmount() ~= self.barrelTarget and self.part:getContainerContentAmount() > 0 then
		local args = { vehicle = self.vehicle:getId(), part = self.part:getId(), amount = drain }
		sendClientCommand(self.character, 'vehicle', 'setContainerContentAmount', args)
		self.fuelStation:setFuelAmount(litres);
	end
	
   -- self.character:setMetabolicTarget(Metabolics.HeavyDomestic);
end

function ISPumpFuelToBarrel:start()
	self.fuelType = self.part:getModData().RSFuelType

	self.tankStart = self.part:getContainerContentAmount()
	self.barrelStart = self.fuelStation:getFuelAmount();
	if self.barrelStart == -1 then
		self.barrelStart = 0;
	end
	local barrelLitresFree = self.fuelStation.fuelCapacity - self.barrelStart
	self.giveLitres = math.min(barrelLitresFree, self.tankStart)
	self.barrelTarget = self.barrelStart + self.giveLitres

	self.action:setTime(self.giveLitres * 10)

	self:setActionAnim("fill_container_tap")
	self:setOverrideHandModels(nil, nil)
	
	self.sound = self.character:playSound("GeneratorLoop")
	self.sound2 = self.character:playSound("GetWaterFromTapMetalBig")
	addSound(self.character, self.character:getX(), self.character:getY(), self.character:getZ(), 10, 1)

end

---stopSound
function ISPumpFuelToBarrel:stopSound()
    if self.sound and self.character:getEmitter():isPlaying(self.sound) then
        self.character:stopOrTriggerSound(self.sound);
		self.character:stopOrTriggerSound(self.sound2);
    end
end

function ISPumpFuelToBarrel:stop()
	self:stopSound()

	if self.fuelStation:getFuelAmount() > self.barrelStart and self.fuelStation.isoObject:getModData().RSFuelType ~= self.fuelType then
		self.fuelStation.isoObject:getModData().RSFuelType = self.fuelType
		self.fuelStation.isoObject:transmitModData();
	end

	ISBaseTimedAction.stop(self)
end

function ISPumpFuelToBarrel:perform()
	self:stopSound()

	if self.fuelStation:getFuelAmount() > self.barrelStart and self.fuelStation.isoObject:getModData().RSFuelType ~= self.fuelType then
		self.fuelStation.isoObject:getModData().RSFuelType = self.fuelType
		self.fuelStation.isoObject:transmitModData();
	end
	
	-- needed to remove from queue / start next.
	ISBaseTimedAction.perform(self)
end

function ISPumpFuelToBarrel:new(character, part, fuelStation, time)
	local o = {}
	setmetatable(o, self)
	self.__index = self
	o.character = character
	o.vehicle = part:getVehicle()
	o.part = part
	o.fuelStation = fuelStation;
	o.maxTime = time
	return o
end

