--------------------------------- Code by Tread ----- (Trealak on Steam) ---------------------------------
------------------------------- Developed For Tread's Fuel Types Framework -------------------------------
------------------------------------------ Remade TIS function -------------------------------------------

require "TimedActions/ISBaseTimedAction"

ISRefuelFromFuelTruckRSFuel = ISBaseTimedAction:derive("ISRefuelFromFuelTruck")

function ISRefuelFromFuelTruckRSFuel:isValid()
	return true
end

function ISRefuelFromFuelTruckRSFuel:waitToStart()
	self.character:faceThisObject(self.vehicle)
	return self.character:shouldBeTurning()
end

function ISRefuelFromFuelTruckRSFuel:update()
	local litres = self.tankStart + (self.tankTarget - self.tankStart) * self:getJobDelta()
	litres = math.floor(litres)
	local pumpUnits = self.pumpStart + (self.pumpTarget - self.pumpStart) * self:getJobDelta()
	pumpUnits = math.ceil(pumpUnits)
	if litres ~= self.amountSent then
		local args = { vehicle = self.vehicle:getId(), part = self.part:getId(), amount = litres }
		sendClientCommand(self.character, 'vehicle', 'setContainerContentAmount', args)
		self.amountSent = litres

		local args2 = { vehicle = self.tank:getVehicle():getId(), part = self.tank:getId(), amount = pumpUnits }
		sendClientCommand(self.character, 'vehicle', 'setContainerContentAmount', args2)
	end

    self.character:setMetabolicTarget(Metabolics.HeavyDomestic);
end

function ISRefuelFromFuelTruckRSFuel:start()
	self.tankStart = self.part:getContainerContentAmount()
	self.pumpStart = self.tank:getContainerContentAmount()
	local pumpLitresAvail = self.pumpStart
	local tankLitresFree = self.part:getContainerCapacity() - self.tankStart
	local takeLitres = math.min(tankLitresFree, pumpLitresAvail)
	self.tankTarget = self.tankStart + takeLitres
	self.pumpTarget = self.pumpStart - takeLitres
	self.amountSent = self.tankStart

	self.action:setTime(takeLitres * 50)

	self:setActionAnim("fill_container_tap")
	self:setOverrideHandModels(nil, nil)

	self.sound = self.character:playSound("GeneratorLoop")
	self.sound2 = self.character:playSound("GetWaterFromTapMetalBig")
	addSound(self.character, self.character:getX(), self.character:getY(), self.character:getZ(), 10, 1)

end

---stopSound
function ISRefuelFromFuelTruckRSFuel:stopSound()
	if self.sound and self.character:getEmitter():isPlaying(self.sound) then
		self.character:stopOrTriggerSound(self.sound);
		self.character:stopOrTriggerSound(self.sound2);
	end
end

function ISRefuelFromFuelTruckRSFuel:stop()
	self:stopSound()

	if self.fuelType == "Gasoline" or self.fuelType == "Diesel" then
		if self.tank:getContainerContentAmount() == 0 then --- Make tank empty (if suitable)
			RSFuelTypes.SwapFuelTypeRS(self.character, self.tank, "Empty")
		end
	end
	if self.part:getModData().RSFuelType == "Empty" and self.part:getContainerContentAmount() > self.tankStart then
		RSFuelTypes.SwapFuelTypeRS(self.character, self.part, self.fuelType) --- Set Fuel Type of previously empty tank
	end
	ISBaseTimedAction.stop(self)
end

function ISRefuelFromFuelTruckRSFuel:perform()
	-- needed to remove from queue / start next.
	self:stopSound()
	if self.fuelType == "Gasoline" or self.fuelType == "Diesel" then
		if self.tank:getContainerContentAmount() == 0 then
			RSFuelTypes.SwapFuelTypeRS(self.character, self.tank, "Empty")
		end
	end
	if self.part:getModData().RSFuelType == "Empty" and self.part:getContainerContentAmount() > self.tankStart then
		RSFuelTypes.SwapFuelTypeRS(self.character, self.part, self.fuelType) --- Set Fuel Type of previously empty tank
	end
	ISBaseTimedAction.perform(self)
end

function ISRefuelFromFuelTruckRSFuel:new(character, part, square, time, source_Tank, fuelType)
	local o = {}
	setmetatable(o, self)
	self.__index = self
	o.character = character
	o.vehicle = part:getVehicle()
	o.part = part
	o.square = square
	o.maxTime = math.max(time, 50)
	o.tank = source_Tank
	o.fuelType = fuelType;
	return o
end

