--------------------------------- Code by Tread ----- (Trealak on Steam) ---------------------------------
------------------------------- Developed For Tread's Fuel Types Framework -------------------------------

local function setContains(set, key) --- function for checking if value is in the table
return set[key] ~= nil
end

----------------------------------------------------------------------------------------------------------
---------------------------------- Assign (Swap) Fuel types to vehicles ----------------------------------
function FuelTypesAPITweakVehicles()
	local swapType = UtilsRS.CarFuelTypesSwap() --- read Fuel Swap method from Sandbox Settings
	local vehicle;
	if swapType == 1 or swapType == 2 then	--- Swaps based on Vehicle Type
		local AllVehicleScripts = getAllVehicles(false)
		for k=0,AllVehicleScripts:size()-1 do
			local vehID = AllVehicleScripts:get(k)
			vehicle = ScriptManager.instance:getVehicle(vehID);
			local vehicleName = vehicle:getFullName()
			local gasTankPresent = vehicle:getPartById("GasTank")
			if gasTankPresent ~= nil and not setContains(RSFuelSwapIgnoreCars, vehicleName) then
				local inOtherLists = setContains(RSForceFuelSwapCars, vehicleName) or setContains(RSMultiFuelSwapCars, vehicleName)  --- Check IF car is in any "Force Type" list
				if swapType == 2 or not inOtherLists then
					local MechanicType = vehicle:getMechanicType()
					if MechanicType == 1 then

					elseif MechanicType == 2 then --- If vehicle is Heavy Duty.
						print('RS Fuel Swap Type 2:  ' .. vehicleName .. " | " .. "Diesel")
						local module, name = vehID:match"([^.]*).(.*)"
						--vehicle:Load(name, "{".."template".." = ".."DieselTank2"..",".."}"); --- Assign Diesel tanks (old version - left for reference)
						--- I hate workaround with xyz2 instead of xyz in template value (and its script file). Still, it works and I am too tired to look further for better way ;).
						vehicle:Load(name, "{ part GasTank { container { contentType = Diesel, } table forcedfuel {} } }"); --- Assign Diesel tanks
					end
				end
			end
		end
	end
	if swapType == 1 or swapType == 3 then	--- Swaps based on Vehicle List
		for vehID, fuelType in pairs(RSForceFuelSwapCars) do
			vehicle = nil
			vehicle = ScriptManager.instance:getVehicle(vehID);
			if vehicle ~= nil then
				local module, name = vehID:match"([^.]*).(.*)"
				print('RS Fuel Swap Forced:  ' .. vehID .. " | " .. fuelType .. " | ")
				--vehicle:Load(name, "{".."template".." = "..fuelType.."Tank"..MechanicType..",".."}"); --- Assign Forced type tanks (old version - left for reference, MechanicType was checked before - now removed)
				vehicle:Load(name, "{ part GasTank { container { contentType = "..fuelType..", } table forcedfuel {} } }");
			end
		end
	end
	if swapType == 1 or swapType == 3 then	--- Swaps based on Vehicle List
		for vehID, multiFuel in pairs(RSMultiFuelSwapCars) do
			vehicle = nil
			vehicle = ScriptManager.instance:getVehicle(vehID);
			if vehicle ~= nil then
				local module, name = vehID:match"([^.]*).(.*)"
				print('RS Fuel Swap Forced:  ' .. vehID .. " | MultiFuel | ")
				--vehicle:Load(name, "{".."template".." = ".."MultiTypeTank"..MechanicType..",".."}"); --- Assign Dynamic tanks  (old version - left for reference, MechanicType was checked before - now removed)
				vehicle:Load(name, "{ part GasTank { table multigastank {}  } }"); --- Assign Dynamic tanks
			end
		end
	end
end
--Events.OnGameBoot.Add(FuelTypesAPITweakVehicles) --- For debugging only (execution is made on game boot - Swaps are logged sooner)
Events.OnGameStart.Add(FuelTypesAPITweakVehicles)	--- Real trigger - so Sandbox options work
